import csv

#importing pandas as pd so we can reference pandas as pd
import pandas as pd

#only add count if it is a uniquely new instance
def count_ngrams(tokens, n):
  """Returns a dictionary mapping tuples of n-grams with order n to the number
    of times that n-gram occurred in list tokens."""
  ngrams = dict()
  if len(tokens) < n:
    return ngrams
  for i in range(len(tokens) - n + 1):
    ngram = tuple(tokens[i:i+n])
    if ngram not in ngrams:
      ngrams[ngram] = 1
    #ngrams[ngram] += 1
  return ngrams

def merge_counts(ngrams_list):
  """Returns a dictionary with counts merged from a list of n-gram count
    dictionaries (such as that returned from count_ngrams)."""
  merged = dict()
  for ngrams in ngrams_list:
    for key, val in ngrams.iteritems():
      if key not in merged:
        merged[key] = 0
      merged[key] += val
  return merged

if __name__ == '__main__':

    #Import the csv using pandas (pd)
  songData = pd.read_csv('chords.csv')

    #Extract the lyrics column and put it in a variable called lyricCol
  lyricCol = songData.chord_progression

#Cycle through the lyricCol and add the values to a string
#The string is called lyricBlob
  lyricBlob = ""

#For every row in lyricCol
#Assign the row to the variable l (one after the other)
  for l in lyricCol:
    #Add the row to the lyricBlob (converted to a string)
    lyricBlob += str(l)
    #Add a space after the row in case there isn't one
    lyricBlob += " "

  #print lyricBlob

#change n-gram here
  n = 1
  counts = list()
  for line in lyricCol:
    line = str(line)
    line = line.strip().split(" ")
    line = [x + " " for x in line]
    counts.append(count_ngrams(list(line), n))
    combined_counts = merge_counts(counts)
    sorted_counts = sorted(combined_counts.items(), key=lambda x: x[1], reverse=True)
  for key, val in sorted_counts:
    print ''.join(key) + ": " + str(val)
